#include "M3Runtime.h"
_PRIVATE _TXT __file = { {0, 1}, "LongFloat.m3", 13};
/*------------------*/
/*------------------*/
_PRIVATE _LONGREAL _longreal[] = {
  1022.0e0,
  0.0e0,
  2.0e0
};
/*------------------*/
/*------------------*/
#define _td156dd0a _LONGREAL
typedef _td156dd0a (*_t739b7e49)();
#define _t95a227bb _VOID
#define _t223565b7 _INTEGER
typedef _td156dd0a (*_t5bf70ac6)();
typedef _t223565b7 (*_t08ef4efc)();
typedef _td156dd0a (*_t1a6a431a)();
#define _t2b3260be unsigned char
typedef _t2b3260be (*_t777e552a)();
#define _t0ab732c9 signed_char
typedef _t0ab732c9 (*_tbe2ccb9e)();
typedef _t2b3260be (*_tdde890a3)();
#define _t5acd7e56 unsigned char
typedef _t5acd7e56 (*_t00678323)();
#define _tae79c988 _t223565b7
#define _t71ad69ac int
#define _t1825dfcb _t71ad69ac
#define _t4395d888 short
#define _t68a27c67 _t4395d888
#define _te4c8e383 _t0ab732c9
struct _rec_tedb3715c {
   _t223565b7 significand1;
   unsigned int significand0 : 20;
   unsigned int exponent : 11;
   unsigned int sign : 1;
};
typedef struct _rec_tedb3715c _tedb3715c;
typedef _t223565b7 (*_t95892aae)();
typedef _t223565b7 (*_t68f0d581)();
#define _tc8c200ad int
/*------------------*/
_EXPORT _td156dd0a LongFloat__Scalb ();
_EXPORT _td156dd0a LongFloat__Logb ();
_EXPORT _t223565b7 LongFloat__ILogb ();
_EXPORT _td156dd0a LongFloat__NextAfter ();
_EXPORT _td156dd0a LongFloat__CopySign ();
_EXPORT _t2b3260be LongFloat__Finite ();
_EXPORT _t2b3260be LongFloat__IsNaN ();
_EXPORT _t0ab732c9 LongFloat__Sign ();
_EXPORT _t2b3260be LongFloat__Differs ();
_EXPORT _t2b3260be LongFloat__Unordered ();
_EXPORT _td156dd0a LongFloat__Sqrt ();
_EXPORT _t5acd7e56 LongFloat__Class ();
_IMPORT _t223565b7 Word__And ();
_IMPORT _t223565b7 Word__RightShift ();
_IMPORT _t223565b7 FPU__IsNaN ();
_IMPORT _td156dd0a FPU__CopySign ();
_IMPORT _t223565b7 FPU__IsFinite ();
_IMPORT _td156dd0a FPU__BinaryPower ();
_IMPORT _td156dd0a Math__sqrt ();
/*------------------*/





/*------------------*/


#line 13 "LongFloat.m3"
  _EXPORT _td156dd0a LongFloat__Scalb (x, n)  _td156dd0a x;  _t223565b7 n;  {  _LOCAL _td156dd0a _result; 

   _td156dd0a _z3; 
#line 13 "LongFloat.m3"
  _result = 0.0; 

   _z3 = FPU__BinaryPower (x, n);  return _z3;   } /* APPROX FRAME SIZE: 44 bytes */ 

#line 18 "LongFloat.m3"
  _EXPORT _td156dd0a LongFloat__Logb (x)  _td156dd0a x;  {  _LOCAL _td156dd0a _result; 

   _t5acd7e56 _z2; 



   _td156dd0a _z1; 

   _tedb3715c _z0;  _tedb3715c _z3; 




   _td156dd0a _z5; 
#line 18 "LongFloat.m3"
  _result = 0.0; 

   _z2 = LongFloat__Class (x);  switch (_z2) {  case 0:  case 1:   

      return x;    case 2:   

      _z1 = x;  if (_z1 < 0.0) _z1 = - _z1;  return _z1;    case 5:   

      _z0.significand1 = (_tae79c988)  0 ;  _z0.significand0 = (_t1825dfcb)  0 ;  _z0.exponent = (_t68a27c67)  2047 ;
#line 26
 _z0.sign = (_te4c8e383)  1 ;  _z3 = _z0;  return (*((_td156dd0a*)(& _z3)));    case 3:   




      _z5 = _CVTIL ((((*((_tedb3715c*)(& x))).exponent) -  1023 ));  return _z5;    case 4:   


      return (-_longreal[0]);    default:;    }   } /* APPROX FRAME SIZE: 68 bytes */ 

#line 38 "LongFloat.m3"
  _EXPORT _t223565b7 LongFloat__ILogb (x)  _td156dd0a x;  {  _LOCAL _tedb3715c xx;  _LOCAL _t223565b7 _result; 



   _t5acd7e56 _z2; 
#line 60
   _t223565b7 _z3; 
#line 38 "LongFloat.m3"
 

   _ZERO2 (& xx);  xx = (*((_tedb3715c*)(& x))); 

   _z2 = LongFloat__Class (x);  switch (_z2) {  case 0:  case 1:   



      _ASSERTFAULT(&__file.str,46);    case 2:   

      return  2147483647 ;    case 5:   

      return  -2147483648 ;    case 3:   

      return ((xx.exponent) -  1023 );    case 4:   

      {  _LOCAL _t223565b7 v;  _LOCAL _t223565b7 n; 


         if (((xx.significand0) == ((_t223565b7) 0 ))) { 
            v =  -2147483648 ; 
            n = (- 1043 ); 
            _L16:   _z3 = v & (xx.significand1);  if (!((_z3 == ((_t223565b7) 0 )))) goto _L17; 
               _z3 = ((unsigned)v) >>  1 ;  v = _z3; 
               n -=  1 ;  goto _L16;   _L17:;  goto _L15;   }   

            v =  524288 ; 
            n = (- 1023 ); 
            _L18:   _z3 = v & (xx.significand0);  if (!((_z3 == ((_t223565b7) 0 )))) goto _L19; 
               _z3 = ((unsigned)v) >>  1 ;  v = _z3; 
               n -=  1 ;  goto _L18;   _L19:;    _L15:; 
         return n;   }    default:;    }   } /* APPROX FRAME SIZE: 52 bytes */ 

#line 72 "LongFloat.m3"
  _EXPORT _td156dd0a LongFloat__NextAfter (x, y)  _td156dd0a x;  _td156dd0a y;  {  _LOCAL _tedb3715c xx;  _LOCAL _td156dd0a _result;
#line 72





   _t2b3260be _z2;  _t2b3260be _z0;  _t2b3260be _z3; 



   _tedb3715c _z1;  _t0ab732c9 _z4;  _tedb3715c _z5; 







   _t2b3260be _z6; 
#line 72 "LongFloat.m3"
 

   _ZERO2 (& xx); 
#line 72
   _result = 0.0; 



   if ((x == ((_td156dd0a)y))) {  return x;   } 
   _z2 = LongFloat__IsNaN (x);  _z0 = 1; if (! _z2) {  _z3 = LongFloat__Finite (x);  _z0 = (!_z3);  }  if (_z0) {
#line 77
 return x;   } 
   _z2 = LongFloat__IsNaN (y);  if (_z2) {  return y;   } 

   if ((x == ((_td156dd0a)_longreal[1]))) { 
      _z1.significand1 = (_tae79c988)  1 ;  _z1.significand0 = (_t1825dfcb)  0 ;  _z1.exponent = (_t68a27c67)  0 ;
#line 81
 _z4 = LongFloat__Sign (y);  _z1.sign = (_te4c8e383) _z4;  _z5 = _z1;  return (*((_td156dd0a*)(& _z5)));   } 





   xx = (*((_tedb3715c*)(& x))); 

   _z3 = 0; if ((x > _longreal[1])) {  _z3 = (x > y);  }  _z0 = 1; if (! _z3) {  _z6 = 0; if ((x < _longreal[1])) {
#line 89
 _z6 = (x < y);  }  _z0 = _z6;  }  if (_z0) { 
      _z6 = 0; if (((xx.significand0) == ((_t223565b7) 0 ))) {  _z6 = ((xx.significand1) == ((_t223565b7) 0 ));  }
#line 90
 if (_z6) { 
         (xx.significand0) =  1048575 ; 
         (xx.significand1) =  -1 ; 
         {  register int _r;  _r = (xx.exponent) -  1 ;  if (_r < 0) _RANGEFAULT(&__file.str,93);  (xx.exponent) = _r;
#line 93
  } 
         if (((xx.exponent) == ((_t223565b7) 0 ))) { 
            return ((_longreal[2] * x) / _longreal[2]);   }  goto _L26;   }   

         if (((xx.significand1) == ((_t223565b7) 0 ))) { 
            (xx.significand1) =  -1 ; 
            {  register int _r;  _r = (xx.significand0) -  1 ;  if (_r < 0) _RANGEFAULT(&__file.str,99);  (xx.significand0) = _r;
#line 99
  }  goto _L28;   }   

            (xx.significand1) -=  1 ;    _L28:;    _L26:;  goto _L25;   }   

      _z6 = 0; if (((xx.significand0) == ((_t223565b7) 1048575 ))) {  _z6 = ((xx.significand1) == ((_t223565b7) -1 ));  }
#line 103
 if (_z6) { 
         (xx.significand0) =  0 ; 
         (xx.significand1) =  0 ; 
         {  register int _r;  _r = (xx.exponent) +  1 ;  if (2047 < _r) _RANGEFAULT(&__file.str,106);  (xx.exponent) = _r;
#line 106
  } 
         if (((xx.exponent) == ((_t223565b7) 2047 ))) { 
            return (x + x);   }  goto _L29;   }   

         if (((xx.significand1) == ((_t223565b7) -1 ))) { 
            (xx.significand1) =  0 ; 
            {  register int _r;  _r = (xx.significand0) +  1 ;  if (1048575 < _r) _RANGEFAULT(&__file.str,112);  (xx.significand0) = _r;
#line 112
  }  goto _L31;   }   

            (xx.significand1) +=  1 ;    _L31:;    _L29:;    _L25:; 

   return (*((_td156dd0a*)(& xx)));   } /* APPROX FRAME SIZE: 100 bytes */ 

#line 119 "LongFloat.m3"
  _EXPORT _td156dd0a LongFloat__CopySign (x, y)  _td156dd0a x;  _td156dd0a y;  {  _LOCAL _td156dd0a _result; 

   _td156dd0a _z3; 
#line 119 "LongFloat.m3"
  _result = 0.0; 

   _z3 = FPU__CopySign (x, y);  return _z3;   } /* APPROX FRAME SIZE: 48 bytes */ 

#line 124 "LongFloat.m3"
  _EXPORT _t2b3260be LongFloat__Finite (x)  _td156dd0a x;  {  _LOCAL _t2b3260be _result; 

   _t223565b7 _z2; 
#line 124 "LongFloat.m3"
  _result = 0; 

   _z2 = FPU__IsFinite (x);  return (_z2 != ((_t223565b7) 0 ));   } /* APPROX FRAME SIZE: 32 bytes */ 

#line 129 "LongFloat.m3"
  _EXPORT _t2b3260be LongFloat__IsNaN (x)  _td156dd0a x;  {  _LOCAL _t2b3260be _result; 

   _t223565b7 _z2; 
#line 129 "LongFloat.m3"
  _result = 0; 

   _z2 = FPU__IsNaN (x);  return (_z2 != ((_t223565b7) 0 ));   } /* APPROX FRAME SIZE: 32 bytes */ 

#line 134 "LongFloat.m3"
  _EXPORT _t0ab732c9 LongFloat__Sign (x)  _td156dd0a x;  {  _LOCAL _t0ab732c9 _result; 
#line 134 "LongFloat.m3"
  _result = 0; 

   return (_t0ab732c9)((*((_tedb3715c*)(& x))).sign);   } /* APPROX FRAME SIZE: 28 bytes */ 

#line 139 "LongFloat.m3"
  _EXPORT _t2b3260be LongFloat__Differs (x, y)  _td156dd0a x;  _td156dd0a y;  {  _LOCAL _t2b3260be _result; 

   _t2b3260be _z3; 
#line 139 "LongFloat.m3"
  _result = 0; 

   _z3 = 1; if (! (x < y)) {  _z3 = (y < x);  }  return _z3;   } /* APPROX FRAME SIZE: 40 bytes */ 

#line 144 "LongFloat.m3"
  _EXPORT _t2b3260be LongFloat__Unordered (x, y)  _td156dd0a x;  _td156dd0a y;  {  _LOCAL _t2b3260be _result; 

   _t2b3260be _z3; 
#line 144 "LongFloat.m3"
  _result = 0; 

   _z3 = 1; if (! (x <= y)) {  _z3 = (y <= x);  }  return (!_z3);   } /* APPROX FRAME SIZE: 40 bytes */ 

#line 149 "LongFloat.m3"
  _EXPORT _td156dd0a LongFloat__Sqrt (x)  _td156dd0a x;  {  _LOCAL _td156dd0a _result; 

   _td156dd0a _z2; 
#line 149 "LongFloat.m3"
  _result = 0.0; 

   _z2 = Math__sqrt (x);  return _z2;   } /* APPROX FRAME SIZE: 40 bytes */ 

#line 154 "LongFloat.m3"
  _EXPORT _t5acd7e56 LongFloat__Class (x)  _td156dd0a x;  {  _LOCAL _tedb3715c xx;  _LOCAL _t5acd7e56 _result; 




   _t2b3260be _z4; 






   _t223565b7 _z3; 
#line 154 "LongFloat.m3"
 

   _ZERO2 (& xx); 
#line 154
   _result = 0; 

   xx = (*((_tedb3715c*)(& x))); 

   if (((xx.exponent) == ((_t223565b7) 0 ))) { 
      _z4 = 0; if (((xx.significand0) == ((_t223565b7) 0 ))) {  _z4 = ((xx.significand1) == ((_t223565b7) 0 ));  }
#line 159
 if (_z4) { 
         return  5 ;   }   

         return  4 ;     } 
   if (((xx.exponent) == ((_t223565b7) 2047 ))) { 
      _z4 = 0; if (((xx.significand0) == ((_t223565b7) 0 ))) {  _z4 = ((xx.significand1) == ((_t223565b7) 0 ));  }
#line 164
 if (_z4) { 
         return  2 ;   } 
      _z3 =  524288  & (xx.significand0);  if ((_z3 == ((_t223565b7) 0 ))) { 
         return  1 ;   }   

         return  0 ;     }   

      return  3 ;     } /* APPROX FRAME SIZE: 44 bytes */ 

#line 171 "LongFloat.m3"
   _LOCAL_PROC _VOID _init_ ()  {  
#line 171 "LongFloat.m3"
   } /* APPROX FRAME SIZE: 16 bytes */ 
/*------------------*/
/*------------------*/
/*------------------*/
/*------------------*/
/*------------------*/
/*------------------*/
/*------------------*/
/*------------------*/
/*------------------*/
/*------------------*/
/*------------------*/
/*------------------*/
/*------------------*/
/*------------------*/
/*------------------*/
/*------------------*/
/*------------------*/
#define _fp_data 0
/*------------------*/
/*------------------*/
#define _exported_full_revelations 0
#define _exported_partial_revelations 0
#define _imported_full_revelations 0
#define _imported_partial_revelations 0

_PRIVATE _PROC_INFO _proc_info [] = {
  { (_PROC) LongFloat__Scalb, 0x739b7e49, "LongFloat.Scalb", 0, 0 },
  { (_PROC) LongFloat__Logb, 0x5bf70ac6, "LongFloat.Logb", 0, 0 },
  { (_PROC) LongFloat__ILogb, 0x08ef4efc, "LongFloat.ILogb", 0, 0 },
  { (_PROC) LongFloat__NextAfter, 0x1a6a431a, "LongFloat.NextAfter", 0, 0 },
  { (_PROC) LongFloat__CopySign, 0x1a6a431a, "LongFloat.CopySign", 0, 0 },
  { (_PROC) LongFloat__Finite, 0x777e552a, "LongFloat.Finite", 0, 0 },
  { (_PROC) LongFloat__IsNaN, 0x777e552a, "LongFloat.IsNaN", 0, 0 },
  { (_PROC) LongFloat__Sign, 0xbe2ccb9e, "LongFloat.Sign", 0, 0 },
  { (_PROC) LongFloat__Differs, 0xdde890a3, "LongFloat.Differs", 0, 0 },
  { (_PROC) LongFloat__Unordered, 0xdde890a3, "LongFloat.Unordered", 0, 0 },
  { (_PROC) LongFloat__Sqrt, 0x5bf70ac6, "LongFloat.Sqrt", 0, 0 },
  { (_PROC) LongFloat__Class, 0x00678323, "LongFloat.Class", 0, 0 },
  { (_PROC)0, 0, 0, 0, 0 }
};
#define _type_info 0
#define _type_cells 0
_EXPORT _LINK_INFO _M_LongFloat = {
  "../../libm3/float/src/DOS386/LongFloat.m3",
  _type_info,
  _fp_data,
  _type_cells,
  _exported_full_revelations,
  _exported_partial_revelations,
  _imported_full_revelations,
  _imported_partial_revelations,
  _proc_info,
  _init_,
  0
};
