
#include <stdio.h>

FILE * file1, * file2;
char buffer [4096];

int main (argc, argv)
  int  argc;
  char ** argv;
  {
    int  count1, count2; 

    if (argc != 3) {
      printf ("usage: %s file1 file2 \n", argv [0]);
      exit (-1);
    }
    
    if (((file1 = fopen (argv [1], "rb")) == NULL) ||
        ((file2 = fopen (argv [2], "wb")) == NULL)) {
      printf ("%s sorry: file error \n", argv [0]);
      exit (-1);
    } 

    while ((count1 = fread (buffer, 1, sizeof (buffer), file1)) != 0) {
      count2 = fwrite (buffer, 1, count1, file2);
      if (count1 != count2) {
        printf ("%s sorry: I/O error \n", argv [0]);
        exit (-1);
      }
    } 
    fclose (file1); fclose (file2);
    return 0;
  }
